package quake;

import java.io.*;

public class mdlread {
        public static void main(String args[])
        throws MDLFormatException, IOException {
                DataInputStream input = new DataInputStream(new FileInputStream(args[0]));
                MDLFile mdl = new MDLFile(input);
                System.out.println("Version " + mdl.getVersion());
                System.out.println("Scale = " + mdl.getScale());
                System.out.println("Origin = " + mdl.getOrigin());
                System.out.println("Radius = " + mdl.getRadius());
                System.out.println("Offsets = " + mdl.getOffsets());
                System.out.println("Number of skins = " + mdl.getNumberOfSkins());
                System.out.println("(" + mdl.getSkinWidth() + " by " + mdl.getSkinHeight() + ")");
                System.out.println("Number of vertices = " + mdl.getNumberOfVertices());
                System.out.println("Number of triangles = " + mdl.getNumberOfTriangles());
                System.out.println("Number of frames = " + mdl.getNumberOfFrameGroups());
                System.out.println("Sync type = " + mdl.getSyncType() + ", flags = " + mdl.getFlags());
                System.out.println("Size = " + mdl.getSize());
                for (int i = 0; i < mdl.getNumberOfSkins(); ++i) {
                        Skin s = mdl.getSkin(i);
                        int n = s.getNumberOfPictures();
                        System.out.println("Skin " + i);
                        System.out.println("\t" + n + " picture(s)");
                        for (int j = 0; j < n; ++j)
                                System.out.println("\t\ttime = " + s.getTime(j));
                }
                for (int i = 0; i < mdl.getNumberOfVertices(); ++i) {
                        TextureVertex t = mdl.getTextureVertex(i);
                        System.out.println("Texture vertex " + i + " onseam = " + t.isOnseam() + " (s,t) = (" + t.getS() + "," + t.getT() + ")");
                }
                for (int i = 0; i < mdl.getNumberOfTriangles(); ++i) {
                        Triangle t = mdl.getTriangle(i);
                        System.out.println("Triangle " + i + " frontfacing = " + t.isFrontFacing() + " points = " + t);
                }
                for (int i = 0; i < mdl.getNumberOfFrameGroups(); ++i) {
                        FrameGroup g = mdl.getFrameGroup(i);
                        System.out.println("Frame group " + i + " (" + g.getNumberOfSubFrames() + " sub-frames)");
                        System.out.println("\tmin = " + g.getMin() + ", max = " + g.getMax());
                        for (int j = 0; j < g.getNumberOfSubFrames(); ++j) {
                                System.out.println("\tSubframe " + j + " (time = " + g.getTime(j) + ")");
                                Frame f = g.getSubFrame(j);
                                System.out.println("\tname = " + f.getName());
                                System.out.println("\tmin = " + f.getMin() + ", max = " + f.getMax());
                                System.out.println("\tvertices:");
                                for (int k = 0; k < mdl.getNumberOfVertices(); ++k)
                                        System.out.println("\t\t" + f.getVertex(k));
                        }

                }
        }
}
